#!/bin/bash

#SBATCH --partition=gpu_shared_course
#SBATCH --gres=gpu:1
#SBATCH --job-name=BA_2MOTIF_TORCH
#SBATCH --ntasks=1
#SBATCH --cpus-per-task=3
#SBATCH --time=03:00:00
#SBATCH --mem=32000M
#SBATCH --output=BA_2MOTIF_TORCH.out

module purge
module load 2019
module load Python/3.7.5-foss-2019b
module load CUDA/10.1.243
module load cuDNN/7.6.5.32-CUDA-10.1.243
module load NCCL/2.5.6-CUDA-10.1.243
module load Anaconda3/2018.12

cd "$HOME/roelrepo/FACTAI21/PGExplainer_torch/"

source activate fact

srun python3 -u train_BA-2motif_LISA.py
srun python3 -u BA-2motif_LISA.py
